----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    19:29:17 04/03/2010 
-- Design Name: 
-- Module Name:    accumulator - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity accumulator is
    Port ( clk : in  STD_LOGIC;
			  ce  : in  STD_LOGIC;
           clr : in  STD_LOGIC;
			  x_ij : in  STD_LOGIC_VECTOR (31 downto 0);
           x_j : out  STD_LOGIC_VECTOR (31 downto 0);
			  oe : out STD_LOGIC);
end accumulator;

architecture Behavioral of accumulator is

signal tmp: STD_LOGIC_VECTOR (31 downto 0);

begin

	process (clk, clr)
	begin
	
		if clk='1' and clk'event then
			if clr='1' then
				tmp <= (others => '0');
			elsif ce='1' then
				tmp <= tmp + x_ij;
			else
				tmp <= tmp;
			end if;
			
			oe <= ce;
		end if;
	
	end process;
	
	x_j <= tmp;

end Behavioral;

