----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:13:55 04/04/2010 
-- Design Name: 
-- Module Name:    switch - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity switch is
    Port ( clk : in  STD_LOGIC;
           ce : in  STD_LOGIC;
			  y_i_in : in  STD_LOGIC_VECTOR (31 downto 0);
			  i_in   : in  STD_LOGIC_VECTOR (7 downto 0);
			  w_ij_in : in  STD_LOGIC_VECTOR (31 downto 0);
			  we : in STD_LOGIC;
           y_i_out : out  STD_LOGIC_VECTOR (31 downto 0);
           w_ij : out  STD_LOGIC_VECTOR (31 downto 0);
			  oe : out STD_LOGIC);
end switch;

architecture Behavioral of switch is

component ram_weight is
	Port ( clk : in  STD_LOGIC;
           we : in  STD_LOGIC;
           ce : in  STD_LOGIC;
           addr : in  STD_LOGIC_VECTOR (7 downto 0);
           di : in  STD_LOGIC_VECTOR (31 downto 0);
           do : out  STD_LOGIC_VECTOR (31 downto 0));
end component;

signal index: STD_LOGIC_VECTOR (31 downto 0);

begin

	U0: ram_weight port map(clk, we, ce, i_in, w_ij_in, w_ij);

	process (clk)
	begin
	
		if clk='1' and clk'event then
			if ce='1' then
				y_i_out <= y_i_in;
			end if;
			
			oe <= ce;
		end if;
		
	end process;

end Behavioral;

