----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    00:56:20 04/20/2010 
-- Design Name: 
-- Module Name:    three_neurons - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity three_neurons is
    Port ( clk : in  STD_LOGIC;
			  ce : in STD_LOGIC;
			  x : in  STD_LOGIC;
			  f : out STD_LOGIC_VECTOR (16 downto 0));
end three_neurons;

architecture Behavioral of three_neurons is


component neuron is
    Port ( clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           ce : in  STD_LOGIC;
           y_i : in  STD_LOGIC_VECTOR (31 downto 0);
           i : in  STD_LOGIC_VECTOR (1 downto 0);
           y_j : out  STD_LOGIC_VECTOR (15 downto 0);
           oe : out  STD_LOGIC);
end component;

component layer2 is
	Port ( clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           ce : in  STD_LOGIC;
           input1 : in  STD_LOGIC_VECTOR (31 downto 0);
           input2 : in  STD_LOGIC_VECTOR (31 downto 0);
           y_i : out  STD_LOGIC_VECTOR (31 downto 0);
           i : out  STD_LOGIC_VECTOR (1 downto 0);
           oe : out  STD_LOGIC);
end component;

signal y_i : STD_LOGIC_VECTOR (31 downto 0);
signal i : STD_LOGIC_VECTOR (1 downto 0);
signal y_j : STD_LOGIC_VECTOR (31 downto 0);
signal j : STD_LOGIC_VECTOR (1 downto 0);
signal ce_2 : STD_LOGIC;
signal ce_2a : STD_LOGIC;
signal ce_2b : STD_LOGIC;
signal ce_3 : STD_LOGIC;
signal ce_4 : STD_LOGIC;

begin

	U0: layer2 port map(clk, reset, ce, input1, "ffffffff", y_i, i, ce_2);
	U1: neuron port map(clk, reset, ce_2, y_i, i, y_j1, ce_2a);
	U2: neuron port map(clk, reset, ce_2, y_i, i, y_j2, ce_2b);
	ce_3 <= ce_2a and ce_2b;
	U3: layer2 port map(clk, reset, ce_3, y_j, j, ce_4);
	U4: neuron port map(clk, reset, ce_4, y_j, i, f, oe);

end Behavioral;

