----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:28:12 04/03/2010 
-- Design Name: 
-- Module Name:    top - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity top is
    Port ( y_i : in  STD_LOGIC_VECTOR (15 downto 0);
           i : in  STD_LOGIC_VECTOR (1 downto 0);
           clk : in  STD_LOGIC;
			  reset : in  STD_LOGIC;
           y_j : out  STD_LOGIC_VECTOR (15 downto 0));
end top;

architecture Behavioral of top is

component switch is
    Port ( y_i_in : in  STD_LOGIC_VECTOR (15 downto 0);
           i_in : in  STD_LOGIC_VECTOR (1 downto 0);
           clk : in  STD_LOGIC;
			  reset : in  STD_LOGIC;
           enable : in  STD_LOGIC;
           y_i_out : out  STD_LOGIC_VECTOR (15 downto 0);
           w_ij : out  STD_LOGIC_VECTOR (15 downto 0));
end component;

component mult is 
	Port ( a : in  STD_LOGIC_VECTOR (15 downto 0);
          b : in  STD_LOGIC_VECTOR (15 downto 0);
          clk : in  STD_LOGIC;
          f : out  STD_LOGIC_VECTOR (31 downto 0));
end component;

component conv_32_to_16 is
    Port ( x : in  STD_LOGIC_VECTOR (31 downto 0);
           f : out  STD_LOGIC_VECTOR (15 downto 0));
end component;

component accumulator is
    Port ( x : in  STD_LOGIC_VECTOR (15 downto 0);
           clk : in  STD_LOGIC;
           clr : in  STD_LOGIC;
           f : out  STD_LOGIC_VECTOR (15 downto 0));
end component;

component sigmoid is
    Port ( z : in  STD_LOGIC_VECTOR (15 downto 0);
           clk : in  STD_LOGIC;
           enable : in  STD_LOGIC;
           y : out  STD_LOGIC_VECTOR (15 downto 0));
end component;

signal x_output: STD_LOGIC_VECTOR (15 downto 0);
signal w_output: STD_LOGIC_VECTOR (15 downto 0);
signal multiplier_output: STD_LOGIC_VECTOR (31 downto 0);
signal accum_input: STD_LOGIC_VECTOR (15 downto 0);
signal accum_output: STD_LOGIC_VECTOR (15 downto 0);

begin

	U0: switch port map(y_i, i, clk, reset, '1', x_output, w_output);
	U1: mult port map(x_output, w_output, clk, multiplier_output);
	U3: accumulator port map(multiplier_output(15 downto 0), clk, reset, y_j);
	-- U4: sigmoid port map(accum_output, clk, '1', y);

end Behavioral;

